## opencamlib 2023.01.11

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15...3.25)

project(OpenCAMLib LANGUAGES CXX)

set( CMAKE_SOURCE_DIR ${CMAKE_SOURCE_DIR}/src )
add_subdirectory( src )
