=== debian/changelog ===
opencamlib (2023.01.11-5build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 22:35:56 +0000

opencamlib (2023.01.11-5) unstable; urgency=medium

  * Team upload.

  * Added Build-Depends-Indep on ghostscript for generating
    documentation images.
  * Updated Standards-Version from 4.6.2 to 4.7.0.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 09 Apr 2024 08:32:45 +0200

opencamlib (2023.01.11-4) unstable; urgency=medium

  * Team upload.

  * Adjusted C++ autopkgtest check to only depend on libopencamlib-dev.
  * Added recommended multi-arch fields.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 06 Sep 2023 08:28:10 +0200

opencamlib (2023.01.11-3) unstable; urgency=medium

  * Team upload.

  * Corrected arch:all builds by only using the opencamlib-doc.docs
    content for installation.
  * Updated formatting for debian/patches/*.patch.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 03 Sep 2023 14:14:28 +0200

opencamlib (2023.01.11-2) unstable; urgency=medium

  * Team upload.

  * Updated Standards-Version from 4.2.1 to 4.6.2.  No changes needed.
  * Corrected 1000-fix-python-paths.patch to install python library
    in opencamlib subdirectory.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 03 Sep 2023 08:38:34 +0200

opencamlib (2023.01.11-1) unstable; urgency=medium

  * Team upload.

  [ Petter Reinholdtsen ]
  * Use annotation in d/patches/.
  * New upstream version 2023.01.11
  * Updated patches and build rules for version 2023.01.11.
  * Dropped 1000-fix-python-paths.patch.

  [ Daniel Gröber ]
  * Upgrade debhelper compat to 13
  * Patch to fix doc target
  * Fix package build by building twice
  * Use DEB_VERSION to fetch version string
  * Replace `which` with command -v
  * Remove unused make vars
  * Fix autopkgtest badpkg error
  * Add autopkgtest building cxx lib example

  [ Petter Reinholdtsen ]
  * Corrected python autopkgtest script to work with python 3
    and new library name.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 27 Aug 2023 07:48:47 +0200

opencamlib (2019.07+dfsg1-2) unstable; urgency=medium

  * Team upload.

  [ Kurt Kremitzki ]
  * Remove debian/files
  * New upstream version 2019.07+dfsg1
  * Add missing texlive-plain-generic dep

  [ Petter Reinholdtsen ]
  * Added gbp.conf to enforce the use or pristine-tar.
  * Adjusted d/copyright shortname from LGPL-2.1 to LGPL-2.1+.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 26 Aug 2023 14:20:01 +0200

opencamlib (2019.07+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Remove Python 2 bindings, build Python 3 bindings

 -- Sabin Iacob <iacobs@m0n5t3r.info>  Sun, 23 Feb 2020 16:17:38 +0200

opencamlib (2018.08+dfsg1-1) unstable; urgency=medium

  * Initial release. (Closes: #905460)
  * Includes Python 2 version.

 -- Kurt Kremitzki <kurt@kwk.systems>  Wed, 29 Aug 2018 01:33:40 -0500
