=== debian/control ===
Source: opencamlib
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Kurt Kremitzki <kurt@kwk.systems>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libboost-graph-dev,
               libboost-python-dev,
               libboost-system-dev,
               python3-all-dev,
Build-Depends-Indep: doxygen,
                     ghostscript,
                     texlive-fonts-recommended,
                     texlive-latex-base,
                     texlive-latex-extra,
                     texlive-plain-generic
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/science-team/opencamlib
Vcs-Git: https://salsa.debian.org/science-team/opencamlib.git
Homepage: http://www.anderswallin.net/cam/

Package: libopencamlib-2023.01
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Provides: libopencamlib
Conflicts: libopencamlib,
           libopencamlib-2018.08,
           libopencamlib-2019.07,
Replaces: libopencamlib
Suggests: opencamlib-doc
Multi-Arch: same
Description: C++ library for creating 3D toolpaths for CNC machines
 OpenCAMLib is a 3D CAM library in C++ with Python bindings. The main
 functionality it provides is axial and radial cutter-projection algorithms
 against polyhedral (triangulated) surfaces.

Package: libopencamlib-dev
Architecture: any
Section: libdevel
Depends: libopencamlib-2023.01 (<< ${binary:Version}+1~),
         libopencamlib-2023.01 (>= ${binary:Version}),
         ${misc:Depends}
Description: C++ library for creating 3D toolpaths for CNC machines - headers
 OpenCAMLib is a 3D CAM library in C++ with Python bindings. The main
 functionality it provides is axial and radial cutter-projection algorithms
 against polyhedral (triangulated) surfaces.
 .
 This package provides development headers for OpenCAMLib.

Package: python3-opencamlib
Section: python
Architecture: any
Depends: python3,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: opencamlib-doc
Description: C++ library for creating 3D toolpaths for CNC machines - Python bindings
 OpenCAMLib is a 3D CAM library in C++ with Python bindings. The main
 functionality it provides is axial and radial cutter-projection algorithms
 against polyhedral (triangulated) surfaces.
 .
 This package contains the Python bindings for OpenCAMLib.

Package: opencamlib-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: python3-opencamlib
Multi-Arch: foreign
Description: C++ library for creating 3D toolpaths for CNC machine - documentation
 OpenCAMLib is a 3D CAM library in C++ with Python bindings. The main
 functionality it provides is axial and radial cutter-projection algorithms
 against polyhedral (triangulated) surfaces.
 .
 This package contains documentation for OpenCAMLib.
